<?php

namespace App\Http\Controllers;

use App\Models\DocumentacionCliente;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Request;

class DocumentacionClienteController extends Controller
{
    /**
     * Display a listing of the resource.
     */
    public function index(): JsonResponse
    {
        $items = DocumentacionCliente::all();

        return response()->json([
            'success' => true,
            'data' => $items,
            'message' => 'Registros obtenidos correctamente',
        ], 200);
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(Request $request): JsonResponse
    {
        $payload = $request->only((new DocumentacionCliente())->getFillable());
        $documentacionCliente = DocumentacionCliente::create($payload);

        return response()->json([
            'success' => true,
            'data' => $documentacionCliente,
            'message' => 'Registro creado correctamente',
        ], 201);
    }

    /**
     * Display the specified resource.
     */
    public function show(DocumentacionCliente $documentacionCliente): JsonResponse
    {
        return response()->json([
            'success' => true,
            'data' => $documentacionCliente,
            'message' => 'Registro obtenido correctamente',
        ], 200);
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(Request $request, DocumentacionCliente $documentacionCliente): JsonResponse
    {
        $payload = $request->only((new DocumentacionCliente())->getFillable());
        $documentacionCliente->update($payload);

        return response()->json([
            'success' => true,
            'data' => $documentacionCliente,
            'message' => 'Registro actualizado correctamente',
        ], 200);
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(DocumentacionCliente $documentacionCliente): JsonResponse
    {
        $documentacionCliente->delete();

        return response()->json([
            'success' => true,
            'message' => 'Registro eliminado correctamente',
        ], 200);
    }
}